<template>
  <single-pane :capt="dictionaryRu.title">
    <ob-table
      :items="[]"
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      is-fixed-header
      ref="obTable"
    />
  </single-pane>
</template>

<script>
import paging     from '@/mixins/dictionaries/paging';
import itemMixin  from '@/mixins/dictionaries/edit-item';
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import ObTable    from 'common-components/src/obComponents/obTable';
import { dictionaryDefault } from '@/translations/ru/default';
import { dictionary } from '@/translations/ru/dictionaries__resources__resource_species';

export default {
  name: 'ResourceSpecies',
  components: {
    ObTable,
    SinglePane
  },
  mixins: [
    paging,
    itemMixin
  ],
  data() {
    return {
      dataGridRefName: 'ResourceSpecies',
      api: {
        source: 'oboz2-dictionary-resource-species-crud/v1/'
      },
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    };
  },
  computed: {
    columnsObTable() {
      return [
        {
          title: this.dictionaryRu.columns.name,
          key: 'name'
        },
        {
          title: this.dictionaryRu.columns.resource_class,
          key: 'resourceClassName'
        },
        {
          title: this.dictionaryRu.columns.resource_sub_types,
          key: 'resourceSubTypes',
          html: function(data) {
            if (data.resourceSubTypes) {
              let types = data.resourceSubTypes.reduce((previous, item) => {
                if (item.title) {
                  return previous + item.title + ', ';
                }
                return previous;
              }, '');
              if (types.length > 2) {
                types = types.slice(0, types.length - 2);
              }
              return types;
            }
            return '';
          }
        },
        {
          title: this.dictionaryRu.columns.status,
          width: 110,
          key: 'isActive',
          html: data => {
            return data.isActive
              ? this.dictionaryRu.status.active
              : this.dictionaryRu.status.inactive;
          }
        }
      ];
    }
  }
};
</script>